require "globals"

function love.load( arg )
--
	-- work around to fix get/set color wonkyness by William Willing
	love.graphics.setColor(255, 255, 255, 255)
	local test = love.graphics.getColor()

	if test < 255 then
	   local f = love.graphics.getColor

	   love.graphics.getColor = function()
	      local difference = 255 - test
	      local r, g, b, a = f()
	      return r + difference, g + difference, b + difference, a + difference
	   end
	end
	-- end work around

	cam:SetBounds( level.map.tileWidth, level.map.tileHeight, ( level.map.width - 1 ) * level.map.tileWidth, ( level.map.height - 1 ) * level.map.tileHeight );
	cam:SetSize(320, 180);
	cam:SetPos(0, 0);

	player:SetBounds(0, 0, level.map.width * level.map.tileWidth, level.map.height * level.map.tileHeight);
	player:SetSize(24, 32);
	player:SetPos( ( 1 * 16 ), 3 * 16 );
	player:SetJumpForce( 7000 );
	player:SetMinVelocity( -500, -900 );
	player:SetMaxVelocity( 500, 1800 );
	player:SetXSpeed( 0 );
	player:SetAcceleration( 10 );
	player:SetDeceleration( 15 );
	
	-- pre-calc slope heights so I merely have to look it up later
	for id, tile in pairs( level.map.tiles ) do
		if( tile.properties.heightmap )then
			level.slopeHeights[ id ] = fromCSV( tile.properties.heightmap );
		end;
	end;
	
	r, g, b, a = love.graphics.getColor();
	
	--ProFi:start();
--
end;

function love.quit()
	--ProFi:stop();
	--ProFi:writeReport( 'MyProfilingReport.txt' );
end;

function love.keypressed(key)   -- we do not need the unicode, so we can leave it out
--
	if ( key == "escape" ) then
		love.event.push("quit");   -- actually causes the app to quit
	end;	

	if ( key == "`" ) then
		debug.debug();   -- actually causes the app to quit
	end;	
	
	if( key == "p" )then
		if( not( p_pressed ) )then
			p_pressed = true;
		else
			p_pressed = false;
		end;
	end;
--
end;

function love.keyreleased(key)
--
--
end;

function UpdatePlayer(dt)
--
	player:GenerateMovementCommands( 
		love.keyboard.isDown( "left" ), love.keyboard.isDown( "right" ) );

	player:Jump( dt, love.keyboard.isDown( "up" ) );

	player:Update( dt, level.map, gravity ); 
--
end;

function love.update(dt)
--	
	accumulator = accumulator + dt;
	
	while accumulator > TIMESTEP do
		
		UpdatePlayer( TIMESTEP );
		
		playerCenterX = player:GetXPos() + (player:GetWidth() / 2);
		playerCenterY = player:GetYPos() + (player:GetHeight() / 2);
		camCenterX = cam.left + (cam.w / 2);
		camCenterY = cam.top + (cam.h / 2);
		
		cam:Move( math.floor(playerCenterX - camCenterX), math.floor(playerCenterY - camCenterY));
		accumulator = accumulator - TIMESTEP;	
	end	
--
end;

function love.draw()
--
	love.graphics.scale( scale );
	
	--DRAW EVERYTHING--
	local ftx, fty = math.floor(-cam.left), math.floor(-cam.top);

	love.graphics.setColor(176, 176, 176, 255);
	love.graphics.rectangle("fill", 0, 0, 320, 180);
	love.graphics.setColor(r, g, b, a);
		
	love.graphics.translate(ftx, fty);
	level.map:autoDrawRange(ftx, fty, scale);
	--map:setDrawRange( cam.left, cam.top, 320, 180 );
	level.map:draw();
			
	player:draw();
	local fpsString = "FPS = " .. love.timer.getFPS();
	love.graphics.setColor(0, 0, 224, 255);
	love.graphics.print(fpsString, cam.left + 240, cam.top + 16);
	love.graphics.setColor(r, g, b, a);
--
end;